#include <string.h>
#include "reg51.h"	              //包含51系统头文件
#include "bst_car.h"	            //包含bst_car.h智能小车头文件

unsigned char pwm_val_left = 0;   //变量定义
unsigned char pwm_val_right = 0;
unsigned char push_val_left ;     //左轮占空比N/20 //速度调节变量 0-20 0最小，20最大
unsigned char push_val_right ;    //右轮占空比N/20 
							   
bit Right_PWM_ON = 1;	           //右轮PWM开关
bit Left_PWM_ON = 1;			       //左轮PWM开关

bit startBit = 0;  				       //串口接收开始标志位
bit newLineReceived = 0; 		     //串口一帧协议包接收完成

unsigned char control=0X03;		   //车运动控制全局变量
unsigned char inputString[50];   //接收数据协议

/*小车运行状态枚举*/
enum{
  enSTOP = 0,
  enRUN,
  enBACK,
  enLEFT,
  enRIGHT
	}enCarState;

#define 	enMinMin() 	{push_val_left =20;push_val_right =20;}
#define 	enMin()	 	{push_val_left =24;push_val_right =24;}
#define 	enMidle()	{push_val_left =28;push_val_right =28;}
#define		enMax()	 	{push_val_left =32;push_val_right =32;}
#define 	run_car     '1'   //按键前
#define 	back_car    '2'   //按键后
#define 	left_car    '3'   //按键左
#define 	right_car   '4'   //按键右
#define 	stop_car    '0'   //按键停

int g_volume = 0;
int g_carstate = 0;
char returntemp[] = "$0,0,0,0,0,0,0,0,0,0,0,0,0#";

//延时函数	
void delay(unsigned int xms)				
{
    unsigned int i,j;
	for(i=xms;i>0;i--)     //i=xms即延时约xms毫秒
    for(j=112;j>0;j--);
}

//前进
 void run(void)
{
	Left_moto_go;     //左轮前进
	Right_moto_go;    //右轮前进
}

//左转
 void leftrun(void)
{	 
	Right_moto_go;     //右轮前进
	Left_moto_Stop;    //左轮停止
}

//右转
void  rightrun(void)
{ 
	Left_moto_go;      //左轮前进
	Right_moto_Stop;   //右轮停止	
}

//后退
void back(void)
{
	Left_moto_back;    //左轮后退
	Right_moto_back;   //右轮后退
}

//停转
void stop(void)
{
	Left_moto_Stop;    //左轮停转
	Right_moto_Stop;   //右轮停转
}

//左旋转
void tleft(void)
{
	Left_moto_back;   //左轮后退
	Right_moto_go;    //右轮前进
}

//右旋转
void tright(void)
{
	Left_moto_go;     //左轮前进
	Right_moto_back;  //右轮后退
}

//PWM调制电机转速  
/************************************************************************/                                 
/*                   左轮调速                                           */
/*调节push_val_left的值改变左电机转速,占空比*/
void pwm_out_left_moto(void)
{  
    if(Left_PWM_ON)
    {
        if(pwm_val_left<=push_val_left)
	    {
	        EN1=1; 
	    }
	    else 
	    {
	        EN1=0;
        }
        if(pwm_val_left>=32)
	    pwm_val_left=0;
    }
    else    
    {
        EN1=0;    //若未开启PWM则EN1=0 左轮 停止
    }
}
/************************************************************************/
/*                    右轮调速                                          */  
/*调节push_val_right的值改变右电机转速,占空比*/
void pwm_out_right_moto(void)
{ 
    if(Right_PWM_ON)
    { 
        if(pwm_val_right<=push_val_right)	//20ms内电平信号 111 111 0000 0000 0000 00
	    {
	        EN2=1; 							//占空比6:20
        }
	    else 
	    {
	        EN2=0;
        }
	    if(pwm_val_right>=32)
	    pwm_val_right=0;
    }
    else    
    {
        EN2=0;    //若未开启PWM则EN2=0 右轮 停止
    }
}
       
       
//TIMER0中断服务子函数产生PWM信号
void timer0()interrupt 1 using 2
{
     TH0=0XFC;	  //1Ms定时
	 TL0=0X66;
	 pwm_val_left++;
	 pwm_val_right++;
	 pwm_out_left_moto();
	 pwm_out_right_moto();
 }	

void timer2()  interrupt 5	 //定时器2
{
	 TF2 = 0;
     TH2 = 0;	  //1Ms定时
	 TL2 = 0;
}
 /******************************************************************/
/* 串口中断程序*/
/******************************************************************/

void UART_SER () interrupt 4
{
	unsigned char n; 	//定义临时变量
	static int num = 0;

	if(RI) 		//判断是接收中断产生
	{
		RI = 0; 	//标志位清零
		n = SBUF;   //读入缓冲区的值

		//control=n;
	    if(n == '$')
	    {
	      startBit = 1;
		  num = 0;
	    }
	    if(startBit == 1)
	    {
	       inputString[num] = n;     
	    }  
	    if (n == '#') 
	    {
	       newLineReceived = 1; 
	       startBit = 0;
	    }
		num++;
		if(num >= 50)
		{
			num = 0;
			startBit = 0;
			newLineReceived	= 0;
		}
	}

}


//PWM初始化
void pwmint(void)
{
	TMOD=0X01;
	TH0= 0XFC;  //1ms定时
    TL0= 0X66;
	TR0= 1;
	ET0= 1;
	EA = 1;	    //开总中断

}

//蓝牙初始化
void WifiInit(void)
{
   
   	SCON = 0x50; 	// SCON: 模式1, 8-bit UART, 使能接收
	TMOD |= 0x20;
	TH1=0xfd; 		//波特率9600 初值
	TL1=0xfd;
	TR1= 1;
	EA = 1;	    	//开总中断
	ES= 1; 			//打开串口中断


}

//串口发送函数
void PutString(unsigned char *TXStr)  
{                
	ES=0;     
	while(*TXStr!=0) 
	{                      
	  SBUF=*TXStr;
	  while(TI==0);
	  TI=0;    
	  TXStr++;
	}
	ES=1; 
}     

//主函数
void main(void)
{	
    pwmint();
	WifiInit();

	while(1)	//无限循环
	{ 
		if (newLineReceived)
	   	{
			switch(inputString[1])
			{
				case run_car:   g_carstate = enRUN; break;
				case back_car:  g_carstate = enBACK;break;
				case left_car:  g_carstate = enLEFT;break;
				case right_car: g_carstate = enRIGHT;break;
				case stop_car:  g_carstate = enSTOP;break;
				default:g_carstate = enSTOP;break;
			}
			if(inputString[3] == '1')  //右旋转
			{
				TR0= 1;
				tright();
				delay(2000); //延时2s 
				stop();
				TR0= 0;
			}
			else if(inputString[3] == '2')	//左旋转
			{
			   	TR0= 1;
				tleft();
				delay(2000); //延时2s 
				stop();
				TR0= 0;
			}
			if(inputString[5] == '1')  //鸣笛
			{
				FM = 0;
				delay(1000);
				FM = 1;
			}
			if(inputString[7] == '1')  //加速
			{
				g_volume++;
				if(g_volume>=4)
				{
					g_volume = 4;
				}
			}
			if(inputString[9] == '1')  //减速
			{
				g_volume--;
				if(g_volume<=0)
				{
					g_volume = 1;
				}
			}   			
			if(inputString[19] == '1')  //灯
			{
				FIRE = (FIRE == 1)?0:1;
			}        

	       PutString(returntemp); //返回协议数据包       
	       
	       newLineReceived = 0;  
		   memset(inputString, 0x00, sizeof(inputString));  
	 
	    }
    
	    switch(g_carstate)
	    {
			case enSTOP: stop();TR0= 0;break;
			case enRUN:run();TR0= 1;break;
			case enLEFT:leftrun();TR0= 1;break;
			case enRIGHT:rightrun();TR0= 1;break;
			case enBACK:back();TR0= 1;break;
			default:stop();TR0= 0;break;
	    }
		switch(g_volume)
		{
			case 1: enMinMin();break;
			case 2: enMin();break;
			case 3: enMidle();break;
			case 4: enMax();break;
			default:enMidle();break;
		}

			 
	 }

}