#include <reg52.h>

sbit IN1 = P1^7;
sbit IN2 = P1^6;
sbit IN3 = P1^5;
sbit IN4 = P1^4;
sbit EN1 = P1^3;
sbit EN2 = P1^2;

void delay(unsigned int time) {
    unsigned int i, j;
    for (i = 0; i < time; i++)
        for (j = 0; j < 120; j++);
}

void motor_control(int speed) {
    if (speed > 0) {
        IN1 = 0;
        IN2 = 1;
        IN3 = 0;
        IN4 = 1;
    } else if (speed < 0) {
        IN1 = 1;
        IN2 = 0;
        IN3 = 1;
        IN4 = 0;
    } else {
        IN1 = 0;
        IN2 = 0;
        IN3 = 0;
        IN4 = 0;
    }
    EN1 = 1;
    EN2 = 1;
}

void main() {
    while (1) {
        motor_control(100); // 控制马达速度为100
        delay(1000); // 延时1秒
        motor_control(-100); // 控制马达速度为-100
        delay(1000); // 延时1秒
    }
}
