#include <reg52.h>
#include <intrins.h>
#include "HC-05.h" // 假设你已经实现了HC-05的串口通信库

sbit IN1 = P1^7;
sbit IN2 = P1^6;
sbit IN3 = P1^5;
sbit IN4 = P1^4;
sbit EN1 = P1^3;
sbit EN2 = P1^2;

void delay(unsigned int time) {
    unsigned int i, j;
    for (i = 0; i < time; i++)
        for (j = 0; j < 120; j++);
}

void motor_control(int speed) {
    if (speed > 0) {
        IN1 = 0;
        IN2 = 1;
        IN3 = 0;
        IN4 = 1;
    } else if (speed < 0) {
        IN1 = 1;
        IN2 = 0;
        IN3 = 1;
        IN4 = 0;
    } else {
        IN1 = 0;
        IN2 = 0;
        IN3 = 0;
        IN4 = 0;
    }
    EN1 = 1;
    EN2 = 1;
}

void main() {
    char received_data;
    while (1) {
        received_data = HCI_ReadData(); // 从HC-05读取数据
        if (received_data == 'F') { // 如果接收到的数据是'F'，则前进
            motor_control(100);
            delay(1000);
        } else if (received_data == 'B') { // 如果接收到的数据是'B'，则后退
            motor_control(-100);
            delay(1000);
        } else if (received_data == 'L') { // 如果接收到的数据是'L'，则左转
            // 在这里添加左转的代码
        } else if (received_data == 'R') { // 如果接收到的数据是'R'，则右转
            // 在这里添加右转的代码
        }
    }
}
